/*
 *	standard system generic function declarations
 *
 *			Copyright  John Wainwright 1988
 *
 */

#include "oic.h"
#include "generics.h"

defGeneric(new, 		newGeneric, 		"new")		/* generic functions .. */
defGeneric(cantDo, 		cantDoGeneric, 		"cantDo")		
defGeneric(eq, 			eqGeneric, 			"eq")		
defGeneric(isEmpty, 	isEmptyGeneric, 	"isEmpty")
defGeneric(init, 		initGeneric, 		"init")
defGeneric(copy, 		copyGeneric, 		"copy")
defGeneric(deepCopy, 	deepCopyGeneric, 	"deepCopy")
defGeneric(dispose, 	disposeGeneric, 	"dispose")
defGeneric(deepDispose, deepDisposeGeneric, "deepDispose")
defGeneric(repList, 	repListGeneric, 	"repList")
defGeneric(print, 		printGeneric, 		"print")
defGeneric(allInstances, allInstancesGeneric, "allInstances")
defGeneric(deepInstances, deepInstancesGeneric, "deepInstances")
defGeneric(supers,		supersGeneric, 		"supers")
defGeneric(subs,		subsGeneric, 		"subs")
defGeneric(className,	classNameGeneric, 	"className")
defGeneric(sequence, 	sequenceGeneric, 	"sequence")	/* sequencer functions */
defGeneric(start, 		startGeneric, 		"start")
defGeneric(next, 		nextGeneric, 		"next")
defGeneric(restart, 	restartGeneric, 	"restart")
defGeneric(moreInSeq,   moreInSeqGeneric,   "moreInSeq")
defGeneric(append, 		appendGeneric, 		"append")	/* list functions ... */
defGeneric(push, 		pushGeneric, 		"push")
defGeneric(head, 		headGeneric, 		"head")
defGeneric(tail, 		tailGeneric, 		"tail")
defGeneric(assoc, 		assocGeneric, 		"assoc")
defGeneric(nth, 		nthGeneric, 		"nth")
defGeneric(second, 		secondGeneric, 		"second")
defGeneric(third, 		thirdGeneric, 		"third")
defGeneric(join, 		joinGeneric, 		"join")
defGeneric(add, 		addGeneric, 		"add")
defGeneric(map, 		mapGeneric, 		"map")
defGeneric(stringOf, 	stringOfGeneric, 	"stringOf")	/* string functions */
defGeneric(draw, 		drawGeneric, 		"draw")

InitSysClasses()		
{
	_InitIndexMixin();
	_InitList();
	_InitReplist();
	_InitString();
	_InitLinkseq();
	_InitCollect();
	_InitList2();
}
