/*
 *	standard system class & generic function declarations
 *			
 *								Copyright - John Wainwright
 *
 */

extern class	Class;
extern class  	Object;
extern class  	List;
extern class  	Replist;
extern class  	String;
extern class  	Linkseq;
extern class  	Collect;
extern class  	List2;
extern class  	IndexMixin;

typedef object	replist;
typedef object	string;
typedef object	list;
typedef object	linkseq;


externGeneric(new, 		newGeneric)				/* generic methods .. */
externGeneric(cantDo, 	cantDoGeneric)			
externGeneric(eq, 		eqGeneric)			
externGeneric(isEmpty,	isEmptyGeneric)
externGeneric(init, 	initGeneric) 
externGeneric(copy, 	copyGeneric)
externGeneric(deepCopy, deepCopyGeneric)
externGeneric(dispose, 	disposeGeneric)
externGeneric(deepDispose, deepDisposeGeneric)
externGeneric(repList, 	repListGeneric)
externGeneric(print, 	printGeneric)
externGeneric(allInstances, allInstancesGeneric)
externGeneric(deepInstances, deepInstancesGeneric)
externGeneric(supers, 	supersGeneric)
externGeneric(subs, 	subsGeneric)
externGeneric(className, classNameGeneric)
externGeneric(sequence, sequenceGeneric)		/* sequencing methods ... 			*/
externGeneric(start, 	startGeneric)
externGeneric(next, 	nextGeneric)
externGeneric(restart, 	restartGeneric)
externGeneric(moreInSeq, moreInSeqGeneric)
externGeneric(append, 	appendGeneric)			/* list methods ... 				*/
externGeneric(push, 	pushGeneric)
externGeneric(head, 	headGeneric)
externGeneric(tail, 	tailGeneric)
externGeneric(assoc, 	assocGeneric)
externGeneric(nth, 		nthGeneric)
externGeneric(second, 	secondGeneric)
externGeneric(third, 	thirdGeneric)
externGeneric(join, 	joinGeneric)
externGeneric(add, 		addGeneric)
externGeneric(map,		mapGeneric)
externGeneric(stringOf, stringOfGeneric)		/* string methods ... 				*/
externGeneric(draw, 	drawGeneric)
